/* CHESS USING BGI GRAPHICS IN C/C++ */
/*
  GRAPHICS DESIGNED & CODED BY         : KK
  GAME ENGINE/LOGIC TO BE DEVELOPED BY : Rajiv A Iyer
*/


#include<stdio.h>
#include<conio.h>
#include<graphics.h>
#include<dos.h>

void rook(int i,int j,int k);
void knight(int i,int j,int k);
void bishop(int i,int j,int k);
void queen(int i,int j,int k);
void king(int i,int j,int k);
void pawn(int i,int j,int k);

void main()
{
 int a=DETECT,b,c;
 int x,y,i,j,k=0,poly[8],l,m=0;

 clrscr();

 initgraph(&a,&b,"\\tc\\bgi");
 x=getmaxx()/8;
 y=getmaxy()/8;

 //setcolor(15);


 for(i=1,k+=y;m<8;i+=y,m++)
 for(j=1,l=0;l<8;j+=x,l++)
 {
  if((l%2==1 && m%2==0) || (l%2==0 && m%2==1))
  {
   setcolor(0);                                /*IN BLACK CHEKS*/
   setfillstyle(1,0);
   poly[0]=j;
   poly[1]=i;
   poly[2]=j+x;
   poly[3]=i;
   poly[4]=j+x;
   poly[5]=k+i;
   poly[6]=j;
   poly[7]=k+i;
   fillpoly(4,poly);

   /*ROOK IN BLACK CHEKS*/
   if((l==7 && m==0) || (l==0 && m==7))
   {
    setcolor(15);
    if(m==0 && l==7)
    {
     setfillstyle(1,15);
    }
   rook(i,j,k);
   }

   /*KNIGHT IN BLACK CHEKS*/
  if((l==1 && m==0) || (l==6 && m==7))
   {
    setcolor(15);
    if(m==0 && l==1)
    {
     setfillstyle(1,15);
    }
   knight(i,j,k);
   }

   /*BISHOP IN BLACK CHECK*/
  if((l==5 && m==0) || (l==2 && m==7))
   {
    setcolor(15);
    if(m==0 && l==5)
    {
     setfillstyle(1,15);
    }
   bishop(i,j,k);
   }

   /*QUEEN IN BLACK CHEK*/
  if(m==7 && l==4)
   {
    setcolor(15);

    queen(i,j,k);
   }
  /*KING IN THE BLACK CHEK*/
  if(m==0 && l==3)
   {
    setcolor(15);
    setfillstyle(1,15);
    king(i,j,k);
   }
   /*PAWN IN BLACK CHEKS*/
  if(m==6 && l%2==1  ||  m==1 && l%2==0)
   {
    setcolor(15);
    if(m==1 && l%2==0)
     setfillstyle(1,15);
    pawn(i,j,k);
   }

  }
  else
  {
   setcolor(15);                                 /*IN WHITE CHEKS*/
   setfillstyle(1,15);
   poly[0]=j;
   poly[1]=i;
   poly[2]=j+x;
   poly[3]=i;
   poly[4]=j+x;
   poly[5]=k+i;
   poly[6]=j;
   poly[7]=k+i;
   fillpoly(4,poly);

   /*ROOK IN WHITE CHEKS*/
   if((l==0 && m==0) || (l==7 && m==7))
   {
    setcolor(0);
    if(m==7 && l==7)
    {
     setfillstyle(1,0);
    }

   rook(i,j,k);
   }

   /*KNIGHT IN WHITE CHEKS*/
   if((l==6 && m==0) || (l==1 && m==7))
   {
    setcolor(0);
    if(m==7 && l==1)
    {
     setfillstyle(1,0);
    }
   knight(i,j,k);
   }

   /*BISHOP IN WHITE CHEKS*/
   if((l==2 && m==0) || (l==5 && m==7))
   {
    setcolor(0);
    if(m==7 && l==5)
    {
     setfillstyle(1,0);
    }
   bishop(i,j,k);
   }

   /*QUEEN IN WHITE CHEK*/
   if(m==0 && l==4)
   {
    setcolor(0);

    queen(i,j,k);
   }

   /*KING IN THE WHITE CHEK*/
   if(m==7 && l==3)
   {
    setcolor(0);
    setfillstyle(1,0);
    king(i,j,k);
   }
    /*PAWN IN WHITE CHEKS*/
   if(m==6 && l%2==0  ||  m==1 && l%2==1)
   {
    setcolor(0);
    if(m==6 && l%2==0)
     setfillstyle(1,0);
    pawn(i,j,k);
   }


  }
 }
 setcolor(15);
 rectangle(0,0,(8*x)+1,(8*y)+1);

  getch();
  closegraph();
}

void rook(int i,int j,int k)
{
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,17,17);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),17,17);
 setcolor(120);

 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,60,14,14);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),90,150,14,14);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),180,240,14,14);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),270,330,14,14);
}

void knight(int i,int j,int k)
{
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,17,17);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),17,17);
 setcolor(120);
 setfillstyle(1,120);

 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,10,10);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),10,10);
}

void bishop(int i,int j,int k)
{
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,17,17);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),17,17);
 setcolor(120);

 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,13,13);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),13,13);

 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),90,180,10,10);

 setfillstyle(1,120);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,3,3);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),3,3);

}

void queen(int i,int j,int k)
{
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,17,17);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),20,20);
 setcolor(120);
 setfillstyle(1,120);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,17,17);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,14,14);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,10,10);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,6,6);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,3,3);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),3,3);
}

void king(int i,int j,int k)
{
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,20,20);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),20,20);
 setcolor(120);
 setfillstyle(1,120);

 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,3,3);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),3,3);
 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,10,10);
 line((j+getmaxx()/16),(k+i)-(getmaxy()/16),(j+getmaxx()/16),((k+i)-(getmaxy()/16))+20);
 line((j+getmaxx()/16),(k+i)-(getmaxy()/16),(j+getmaxx()/16),((k+i)-(getmaxy()/16))-20);
 line((j+getmaxx()/16),(k+i)-(getmaxy()/16),(j+getmaxx()/16)-20,((k+i)-(getmaxy()/16)));
 line((j+getmaxx()/16),(k+i)-(getmaxy()/16),(j+getmaxx()/16)+20,((k+i)-(getmaxy()/16)));
}

void pawn(int i,int j,int k)
{
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),10,10);
 setcolor(120);
 setfillstyle(1,120);

 ellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),0,360,3,3);
 fillellipse((j+getmaxx()/16),(k+i)-(getmaxy()/16),3,3);
}

















